/**
 * Copyright (C) 2003-2004 Funambol
 *
 *  This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#ifndef INCL_RAPIDB
#define INCL_RAPIDB

#define MAX_LEN_DBNAME 32

#define FIELD_NAME_VOLUME      "volume"
#define FIELD_TYPE_VOLUME      "Ljava/lang/String;"
#define FIELD_NAME_DBNAME      "dbName"
#define FIELD_TYPE_DBNAME      "Ljava/lang/String;"
#define FIELD_NAME_DBHANDLE    "dbHandle"
#define FIELD_TYPE_DBHANDLE    "J"
#define FIELD_NAME_VOLOID      "volOid"
#define FIELD_TYPE_VOLOID      "[B"
#define FIELD_NAME_DBOID       "dbOid"
#define FIELD_TYPE_DBOID       "J"
#define FIELD_NAME_KEYFIELD    "keyField"
#define FIELD_TYPE_KEYFIELD    "I"
#define FIELD_NAME_STATUSFIELD "statusField"
#define FIELD_TYPE_STATUSFIELD "I"
#define FIELD_NAME_SORTFIELD   "sortField"
#define FIELD_TYPE_SORTFIELD   "I"

#define CLASS_DATA_ACCESS_EXCEPTION "sync4j.syncclient.sps.common.DataAccessException"
#define CLASS_EXCEPTION "java.lang.Exception"

#define CHECK_RAPI     0x0001
#define CHECK_DBHANDLE 0x0002


/*
 * Data
 */
static BOOL initialized;

/*
 * Functions
 */
static jstring  getDBName   (JNIEnv *, jobject);
static jstring  getVolume   (JNIEnv *, jobject);
static void     setDBHandle (JNIEnv *, jobject, HANDLE);
static HANDLE   getDBHandle (JNIEnv *, jobject);
static void     setDBOid (JNIEnv *, jobject, CEOID);
static CEOID    getDBOid (JNIEnv *, jobject);
static void     setVolOid (JNIEnv *, jobject, PCEGUID);
static void     getVolOid (JNIEnv *, jobject, PCEGUID);
static void     setKeyField (JNIEnv *, jobject, int);
static int      getKeyField (JNIEnv *, jobject);
static void     setStatusField (JNIEnv *, jobject, int);
static int      getStatusField (JNIEnv *, jobject);
static void     setSortField (JNIEnv *, jobject, int);
static int      getSortField (JNIEnv *, jobject);

static jfieldID getFieldID  (JNIEnv *, jobject, const char*, const char*);
static jobjectArray getRecordValues(JNIEnv *, CEOID, LPBYTE, WORD);
static jobject getFieldValue(JNIEnv *, CEPROPVAL*, WORD);
static jobject newByteArray(JNIEnv *env, DWORD len, BYTE value[]);
static jobject newBoolean(JNIEnv *env, jboolean value);
static jobject newInteger(JNIEnv *env, jint value);
static jobject newLong(JNIEnv *env, jlong value);
static jobject newDouble(JNIEnv *env, jdouble value);
static jobject newString(JNIEnv *env, WCHAR *value);
static jobject newDate(JNIEnv *env, FILETIME*);

static void init();
static void uninit();
static BOOL sanityCheck(JNIEnv *env, jobject o, WORD flags);


#endif